//
//  CanvasView.m
//  LayerTest
//
//  Created by Thomas Anthony on 6/5/13.
//  Copyright (c) 2013 Thomas Anthony. All rights reserved.
//

#import "CanvasView.h"

@implementation CanvasView
{
    UIBezierPath *path;
    CGPoint points[5];
    uint counter;
}

- (id)initWithCoder:(NSCoder *)aDecoder
{
    if (self = [super initWithCoder:aDecoder])
    {
        self.backgroundColor = [UIColor whiteColor];
        self.multipleTouchEnabled = NO;
        path = [UIBezierPath bezierPath];
        path.lineWidth = 6.0f;
    }
    return self;
}

- (id)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        self.backgroundColor = [UIColor whiteColor];
        self.multipleTouchEnabled = NO;
        path = [UIBezierPath bezierPath];
        path.lineWidth = 2.0f;
    }
    return self;
}

- (void)drawRect:(CGRect)rect
{
    [self.image drawInRect:rect];
    [[UIColor blueColor] setStroke];
    [path stroke];
}

- (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event
{
    counter = 0;
    UITouch *touch = [touches anyObject];
    points[counter] = [touch locationInView:self];
}

- (void)touchesMoved:(NSSet *)touches withEvent:(UIEvent *)event
{
    UITouch *touch = [touches anyObject];
    counter++;
    points[counter] = [touch locationInView:self];
    
    if (counter == 4)
    {
        points[3] = CGPointMake((points[2].x + points[4].x) / 2.0f,
                                (points[2].y + points[4].y) / 2.0f);
        [path moveToPoint:points[0]];
        [path addCurveToPoint:points[3] controlPoint1:points[1] controlPoint2:points[2]];
        [self setNeedsDisplay];
        points[0] = points[3];
        points[1] = points[4];
        counter = 1;
    }
}

- (void)touchesEnded:(NSSet *)touches withEvent:(UIEvent *)event
{
    [self drawBitmap];
    [self setNeedsDisplay];
    [path removeAllPoints];
    counter = 0;
}

- (void)touchesCancelled:(NSSet *)touches withEvent:(UIEvent *)event
{
    [self touchesEnded:touches withEvent:event];
}

- (void)drawBitmap
{
    UIGraphicsBeginImageContextWithOptions(self.bounds.size, YES, 0.0f);
    if (!self.image)
    {
        UIBezierPath *rectPath = [UIBezierPath bezierPathWithRect:self.bounds];
        [[UIColor whiteColor] setFill];
        [rectPath fill];
    }
    [self.image drawAtPoint:CGPointZero];
    [[UIColor blueColor] setStroke];
    [path stroke];
    self.image = UIGraphicsGetImageFromCurrentImageContext();
    UIGraphicsEndImageContext();
}

@end
